module SPC_Tests (tests) where

import Control.Concurrent (threadDelay)
import Control.Monad (forM, forM_, replicateM)
import Data.IORef
import SPC
import GenServer
import Test.Tasty (TestTree, localOption, mkTimeout, testGroup)
import Test.Tasty.HUnit (assertFailure, testCase, (@?=))
import Data.Either (isRight)

tests :: TestTree
tests =
  localOption (mkTimeout 3000000) $
    testGroup
      "SPC (core)"
      [
        testCase "worker-add" $ do
          spc <- startSPC
          w <- workerAdd spc "R2-D2"
          isRight w @?= True,
        testCase "worker-add-2" $ do
          spc <- startSPC
          _ <- workerAdd spc "MSE-6"
          w <- workerAdd spc "GNK"
          isRight w @?= True,
        testCase "worker-add-3" $ do
          spc <- startSPC
          _ <- workerAdd spc "C-3PO"
          _ <- workerAdd spc "K-2SO"
          w <- workerAdd spc "IG-88"
          isRight w @?= True,
        testCase "worker-add-2-fail" $ do
          spc <- startSPC
          _ <- workerAdd spc "BD-1"
          w <- workerAdd spc "BD-1"
          isRight w @?= False
      ]
